/*
 * byojundo.h
 * byojeopardy
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

enum {UNDO_DELETE, UNDO_COPY, UNDO_INSERT, UNDO_EDIT, UNDO_MOVE};

struct s_value
{
	gchar * value_string;
	gchar * question_string;
	gchar * answer_string;
	gint position;
};
typedef struct s_value value_struct;

struct s_topic
{
	gint position;
	gchar * topic_string;
	GList * values;
};
typedef struct s_topic topic;

struct s_undo
{
	gint action; // delete | insert | move ...
	gint pos;
	topic * topic_data;
	GtkTreePath *path;
	int iter_type;
	gchar * column_string;
	GtkTreePath *path_selected;
};
typedef struct s_undo undo;

int
byoj_get_topic_position(GtkTreeModel *tree_model, GtkTreeIter * iter);

int
byoj_get_value_position(GtkTreeModel *tree_model, GtkTreeIter * iter);

void
byoj_undo_store_data_for_delete(GtkTreeModel *tree_model, GtkTreeIter * iter, undo * undo_data);

void 
byoj_undo_setup(GtkWidget *treeview);

void byoj_undo_clear_undos();

void byoj_undo_add_undo (gint undo_type, GtkTreeIter * iter);
void byoj_undo_add_redo (gint undo_type, GtkTreeIter * iter);

int byoj_undo_has_undo ();
int byoj_undo_has_redo ();

void byoj_undo_undo ();
void byoj_undo_redo ();
